package es.us.ccia.dummy.dibujo.ventanas;
/**
 * Version 0.9: 
 * 
 *    20080715
 *    - Implementacion inicial
 *           
 *==================================================
 * TODO: 
 *       
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.DefaultListModel;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;

import es.us.ccia.dummy.dibujo.GUI;


/***
 * 
 * @author Gonzalo A. Aranda Corral
 * @version 0.9.0
 * @since   12/07/2008
 *
 */
@SuppressWarnings({"serial","unchecked"})
public class VentanaRelaciones extends JComponent {

	JList lista;
	DefaultListModel Lmodelo;
	JScrollPane panelCls;
   
	public VentanaRelaciones(GUI g) {
		super();		
		lista   = new JList();
		lista.setCellRenderer(new RelacionRenderer());
    	Lmodelo = new DefaultListModel();
    	lista.setModel(Lmodelo);
    	
        lista.addListSelectionListener(null);
    	
        actualizar(null);
        
    	panelCls = new JScrollPane(lista);
    	panelCls.setSize(100, 300);
    	    	
        setLayout(new BorderLayout());
        add(panelCls,BorderLayout.CENTER);

	}


	public void actualizar(LinkedList lista) {

		Lmodelo.clear();
		
		if (lista != null) {
			Iterator i = lista.iterator();
			
			while(i.hasNext()) {
				String rr = (String)i.next();
				ElementoLista cl = new ElementoLista(rr);
//				cl.Consist = rr.estaSeleccionada();
				Lmodelo.addElement(cl);	
			}
		}
		
	}

//	public void addRelacion(Relacion relacion) {
//		if (relacion.getTipo()>0) {
//			ElementoLista cl = new ElementoLista(relacion.toString());
//			Lmodelo.addElement(cl);	
//		}
//			//Lmodelo.addElement(relacion.toString());
//	}

	
	public void vaciar() {
		Lmodelo.clear();
	}
	
	
	public ArrayList getSeleccion() {
		
		ArrayList devolver = new ArrayList();
		int tamano = lista.getSelectedIndices().length;
		
		for(int indice=0;indice<tamano;indice++) {
			//devolver.add(lista.getSelectedValues()[indice].toString());
			devolver.add(lista.getSelectedValues()[indice]);
		}
		
		return devolver;
	}
	

	
	
}

/***********************************************
 * 
 * 
 * @author garanda
 *
 */

@SuppressWarnings("serial")
class RelacionRenderer extends JLabel implements ListCellRenderer {
 
private static final Color HIGHLIGHT_COLOR = new Color(0, 0, 128);

  public RelacionRenderer() {
    setOpaque(true);
    setIconTextGap(12);
  }

  public Component getListCellRendererComponent(JList list, Object value,
      int index, boolean isSelected, boolean cellHasFocus) {

	  if (value != null) {
	  
	  ElementoLista entry = (ElementoLista) value;
  
	  //setIcon(Icons.getClsesAndInstancesIcon()   );
	  setText(entry.getNombre().toUpperCase());

	setBackground(Color.white);
	setForeground(Color.black);
    
//    if (isSelected) {
	if (isSelected || entry.Consist) {
			setBackground(HIGHLIGHT_COLOR);
			setForeground(Color.white);
        	this.setFont(new Font("Default",Font.BOLD,12));
    	
    } else {
		setBackground(Color.white);
		setForeground(Color.black);
    		this.setFont(new Font("Default",Font.PLAIN,12));	
    }
	  }
    return this;
  }
}
